"""
 id: install_flashmovies
 title: Install FlashMovies *optional*
 module name: CMFFlashMovie.Install
 function name: install
"""

from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.ContentTypeRegistry import ContentTypeRegistry
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFFlashMovie import FlashMovie, flashmovie_globals
from cStringIO import StringIO
import string

def install(self):
    """register the CMF FlashMovie content"""
    typestool = getToolByName(self, 'portal_types')
    skinstool = getToolByName(self, 'portal_skins')
    metadatatool = getToolByName(self, 'portal_metadata')
    catalog = getToolByName(self, 'portal_catalog')
    c_catalog = catalog._catalog
    
    # setup typetool
    for t in FlashMovie.factory_type_information:
        if t['id'] not in typestool.objectIds():
            cfm = apply(ContentFactoryMetadata, (), t)
            typestool._setObject(t['id'], cfm)

#    try:
#        metadatatool.addElementPolicy(element='Subject',
#                                      content_type='FlashMovie',
#                                      is_required=0,
#                                      supply_default=0,
#                                      default_value='',
#                                      enforce_vocabulary=0,
#                                      allowed_vocabulary=(),
#                                      REQUEST=None)
#    except:
#        print 'Cannot add element policy'

      
    # setup content_type_registry entry
    ctr = getToolByName(self, 'content_type_registry')
    if not ctr.getPredicate('flashmovie'):
        ctr.addPredicate('flashmovie','extension')
    ctr.getPredicate('flashmovie').edit(extensions="swf")
    ctr.assignTypeName('flashmovie', 'FlashMovie') 
    ctr.reorderPredicate('flashmovie',0)  
     
    # setup skins
    if 'flashmovie' not in skinstool.objectIds():
        addDirectoryViews(skinstool, 'skins', flashmovie_globals)

    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map( string.strip, string.split(path, ','))
        if 'flashmovie' not in path:
            try: path.insert(path.index('content'), 'flashmovie')
            except ValueError:
                path.append('flashmovie')

            path = string.join(path, ', ')
            skinstool.addSkinSelection(skin, path)

    return 'OK'

